// -------------------------------------------------------------------------------
// 
// 		cwCu		\tgEFAň摜vOwb_t@C
// 
// 				Ver 3.16d
// 
// -------------------------------------------------------------------------------

#ifndef __DXSOFTIMAGE_H__
#define __DXSOFTIMAGE_H__

// CN[h ------------------------------------------------------------------
#include "DxCompileConfig.h"

#ifndef DX_NON_SOFTIMAGE
#include "DxHandle.h"
#include "DxBaseImage.h"

#ifndef DX_NON_NAMESPACE

namespace DxLib
{

#endif // DX_NON_NAMESPACE

// }N` --------------------------------------------------------------------

// \tgC[Wnh̗L`FbN
#define SFTIMGCHK( HAND, SPOINT )			HANDLECHK(       DX_HANDLETYPE_SOFTIMAGE, HAND, *( ( HANDLEINFO ** )&SPOINT ) )
#define SFTIMGCHK_ASYNC( HAND, SPOINT )		HANDLECHK_ASYNC( DX_HANDLETYPE_SOFTIMAGE, HAND, *( ( HANDLEINFO ** )&SPOINT ) )

// \̒` --------------------------------------------------------------------

// \tgC[W̏\
struct SOFTIMAGE
{
	HANDLEINFO				HandleInfo ;			// nhʃf[^
	BASEIMAGE				BaseImage ;				// {C[W\
} ;

// \tgEGAň摜̏\
struct SOFTIMAGEMANAGE
{
	int						InitializeFlag ;			// tO
} ;

// ϐ錾 --------------------------------------------------------------

extern SOFTIMAGEMANAGE SoftImageManage ;

// ֐vg^Cv錾-----------------------------------------------------------

// An
extern	int		InitializeSoftImageManage( void ) ;										// \tgC[WǗ̏
extern	int		TerminateSoftImageManage( void ) ;										// \tgC[WǗ̌n

// ǂݍ݊֘A
extern	int		InitializeSoftImageHandle( HANDLEINFO *HandleInfo ) ;															// \tgEGAC[Wnh̏
extern	int		TerminateSoftImageHandle( HANDLEINFO *HandleInfo ) ;															// \tgEGAC[Wnȟn
extern	int		LoadSoftImage_UseGParam( const wchar_t *FileName, int ASyncLoadFlag = FALSE ) ;									// LoadSoftImage ̃O[oϐɃANZXȂo[W
extern	int		LoadSoftImageToMem_UseGParam( void *FileImage, int FileImageSize, int ASyncLoadFlag = FALSE ) ;					// LoadSoftImageToMem ̃O[oϐɃANZXȂo[W


// wchar_tŊ֐
extern	int		LoadSoftImage_WCHAR_T(              const wchar_t *FileName ) ;
#ifndef DX_NON_FONT
extern	int		BltStringSoftImage_WCHAR_T(         int x, int y, const wchar_t *StrData, int DestSIHandle, int DestEdgeSIHandle = -1 ,                                        int VerticalFlag = FALSE ) ;
extern	int		BltStringSoftImageToHandle_WCHAR_T(	int x, int y, const wchar_t *StrData, int DestSIHandle, int DestEdgeSIHandle /* KvȂꍇ -1 */ , int FontHandle, int VerticalFlag = FALSE ) ;
#endif // DX_NON_FONT

#ifndef DX_NON_SAVEFUNCTION
extern	int		SaveSoftImageToBmp_WCHAR_T(         const wchar_t *FilePath, int SIHandle ) ;
#ifndef DX_NON_PNGREAD
extern	int		SaveSoftImageToPng_WCHAR_T(         const wchar_t *FilePath, int SIHandle, int CompressionLevel ) ;
#endif // DX_NON_PNGREAD
#ifndef DX_NON_JPEGREAD
extern	int		SaveSoftImageToJpeg_WCHAR_T(        const wchar_t *FilePath, int SIHandle, int Quality, int Sample2x1 ) ;
#endif // DX_NON_JPEGREAD
#endif // DX_NON_SAVEFUNCTION



#ifndef DX_NON_NAMESPACE

}

#endif // DX_NON_NAMESPACE

#endif // DX_NON_SOFTIMAGE

#endif // __DXSOFTIMAGE_H__

